Index: trunk/kernel/devices/dev_mmc.c
===================================================================
--- trunk/kernel/devices/dev_mmc.c	(revision 690)
+++ trunk/kernel/devices/dev_mmc.c	(revision 1)
@@ -2,5 +2,5 @@
  * dev_mmc.c - MMC (Memory Cache Controler) generic device API implementation.
  * 
- * Author  Alain Greiner    (2016,2017,2018,2019,2020)
+ * Author  Alain Greiner    (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -22,11 +22,9 @@
  */
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 #include <hal_special.h>
-#include <hal_drivers.h>
+#include <soclib_mmc.h>
 #include <printk.h>
-#include <chdev.h>
 #include <thread.h>
-#include <remote_busylock.h>
 #include <dev_mmc.h>
 
@@ -35,146 +33,144 @@
 /////////////////////////////////////////////////////////////////////////////////////////
 
-extern chdev_directory_t  chdev_dir;         // allocated in kernel_init.c
+extern devices_directory_t  devices_dir;         // allocated in kernel_init.c
+
+extern devices_input_irq_t  devices_input_irq;   // allocated in kernel_init.c
 
 //////////////////////////////////
-void dev_mmc_init( chdev_t * mmc )
-{
-    // set mmc name
-    snprintk( mmc->name , 16 , "mmc_%x" , local_cxy );
-
-    // call driver init function
-    hal_drivers_mmc_init( mmc );
-
-    // bind IRQ to CP0
-    dev_pic_bind_irq( 0 , mmc );
-   
-    // enable IRQ
-    dev_pic_enable_irq( 0 , XPTR( local_cxy , mmc ) );
-
+void dev_mmc_init( xptr_t dev_xp )
+{
+    // get MMC device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get implementation from device descriptor
+    uint32_t  impl = hal_remote_lw( XPTR( dev_cxy , &dev_ptr->impl ) );
+
+    // set driver specific fields in device descriptor
+    // and call driver init function
+    if( impl == IMPL_MMC_TSR )
+    {
+        hal_remote_spt( XPTR( dev_cxy , &dev_ptr->cmd ) , &soclib_mmc_command );
+        hal_remote_spt( XPTR( dev_cxy , &dev_ptr->isr ) , &soclib_mmc_isr );
+        hal_remote_memcpy( XPTR( dev_cxy , &dev_ptr->name ),
+                           XPTR( local_cxy , "MMC_TSR" ) , 16 );
+        soclib_mmc_init( dev_xp );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s: undefined MMC device implementation\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
 }  // end dev_mmc_init()
 
 /////////////////////////////////////////////////////////////////////////////
-// This static function is called by all MMC device access functions.
-// It makes some checking, takes the lock granting exclusive
-// access to MMC peripheral, call the driver to execute the command
+// This static function makes some checking, takes the lock granting
+// exclusive access to MMC peripheral, call the driver to execute the command
 // registered in the calling thread descriptor, and releases the lock.
 /////////////////////////////////////////////////////////////////////////////
-static error_t dev_mmc_access( thread_t * this )
-{
-    // get extended pointer on MMC device descriptor
-    xptr_t  dev_xp = this->mmc_cmd.dev_xp;
-
-    assert( __FUNCTION__, (dev_xp != XPTR_NULL) , "target MMC device undefined" );
+static void dev_mmc_access( thread_t * this )
+{
+    mmc_dmsg("\n[INFO] %s enters for thread %x in process %x : command = %d\n", 
+                 __FUNCTION__ , this->trdid , this->process->pid , this->dev.mmc.type );
+
+    // get extended pointer on MMC device
+    xptr_t  dev_xp  = this->dev.mmc.dev_xp;
+
+    if ( dev_xp == XPTR_NULL )
+    {
+        printk("\n[PANIC] in %s : undefined MMC device descriptor "
+               "in cluster %x for thread %x in process %x\n",
+               __FUNCTION__ , local_cxy , this->trdid , this->process->pid );
+        hal_core_sleep();
+    }
 
     // get MMC device cluster identifier & local pointer
-    cxy_t     dev_cxy = GET_CXY( dev_xp );
-    chdev_t * dev_ptr = GET_PTR( dev_xp );
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
 
     // get driver command function pointer from MMC device descriptor
     dev_cmd_t * cmd = (dev_cmd_t *)hal_remote_lpt( XPTR( dev_cxy , &dev_ptr->cmd ) );
 
-    // get the MMC device remote busylock
-    remote_busylock_acquire( XPTR( dev_cxy , &dev_ptr->wait_lock ) );  
+    // get the MMC device remote spinlock
+    remote_spinlock_lock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );  
 
     // call driver command
     cmd( XPTR( local_cxy , this ) );
     
-    // release the MMC device remote busylock
-    remote_busylock_release( XPTR( dev_cxy , &dev_ptr->wait_lock ) );  
-
-    // return operation status
-    return this->mmc_cmd.error;  
+    // release the MMC device remote spinlock
+    remote_spinlock_unlock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );  
+
+    mmc_dmsg("\n[INFO] %s completes for thread %x in process %x / error = %d\n", 
+                 __FUNCTION__ , this->trdid , this->process->pid , this->dev.ioc.error );
 
 }  // end dev_mmc_access()
 
+////////////////////////////////////////////
+error_t dev_mmc_inval( paddr_t    buf_paddr,
+                       uint32_t   buf_size )
+{
+    // get calling thread local pointer
+    thread_t * this = CURRENT_THREAD;
+
+    // get target cluster from paddr
+    cxy_t cxy = CXY_FROM_PADDR( buf_paddr );
+
+    if ( buf_paddr & (CONFIG_CACHE_LINE_SIZE -1) )
+    {
+        printk("\n[PANIC] in %s : buffer not aligned on cache line "
+               "for thread %x / target cluster %x\n",
+               __FUNCTION__ , this->trdid , cxy );
+        hal_core_sleep();
+    }
+
+    // get extended pointer on MMC device descriptor
+    xptr_t  dev_xp = devices_dir.mmc[cxy];
+
+    // store command arguments in thread descriptor
+    this->dev.mmc.dev_xp    = dev_xp;
+    this->dev.mmc.type      = MMC_CC_INVAL;
+    this->dev.mmc.buf_paddr = buf_paddr;
+    this->dev.mmc.buf_size  = buf_size;
+
+    // execute operation
+    dev_mmc_access( this ); 
+
+    // return operation status
+    return this->dev.mmc.error;  
+}  
+
+/////////////////////////////////////
+error_t dev_mmc_sync( paddr_t    buf_paddr,
+                      uint32_t   buf_size )
+{
+    // get calling thread local pointer
+    thread_t * this = CURRENT_THREAD;
+
+    // get target cluster from paddr
+    cxy_t cxy = CXY_FROM_PADDR( buf_paddr );
+
+    if ( buf_paddr & (CONFIG_CACHE_LINE_SIZE -1) )
+    {
+        printk("\n[PANIC] in %s : buffer not aligned on cache line "
+               "for thread %x / target cluster %x\n",
+               __FUNCTION__ , this->trdid , cxy );
+        hal_core_sleep();
+    }
+
+    // store command arguments in thread descriptor
+    this->dev.mmc.dev_xp    = devices_dir.mmc[cxy];
+    this->dev.mmc.type      = MMC_CC_SYNC;
+    this->dev.mmc.buf_paddr = buf_paddr;
+    this->dev.mmc.buf_size  = buf_size;
+
+    // execute operation
+    dev_mmc_access( this ); 
+
+    // return operation status
+    return this->dev.mmc.error;  
+}  
+
 /////////////////////////////////////////
-error_t dev_mmc_inval( xptr_t     buf_xp,
-                       uint32_t   buf_size )
-{
-    error_t error;
-
-    // get calling thread local pointer
-    thread_t  * this    = CURRENT_THREAD;
-
-#if DEBUG_DEV_MMC
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEV_MMC < cycle )
-printk("\n[%s] thread[%x,%x] enters / cluster %x / buffer %x\n", 
-__FUNCTION__, this->process->pid, this->trdid, GET_CXY(buf_xp), GET_PTR(buf_xp) );
-#endif
-
-    // get buffer cluster and local pointer
-    cxy_t     buf_cxy = GET_CXY( buf_xp );
-    uint8_t * buf_ptr = GET_PTR( buf_xp );
-    
-    // force buffer align
-    uint32_t  delta = (uint32_t)buf_ptr & (CONFIG_CACHE_LINE_SIZE - 1); 
-    uint8_t * base  = buf_ptr - delta;
-    uint32_t  size  = buf_size + delta;
-
-    // store command arguments in thread descriptor
-    this->mmc_cmd.dev_xp    = chdev_dir.mmc[buf_cxy];
-    this->mmc_cmd.type      = MMC_CC_INVAL;
-    this->mmc_cmd.buf_ptr   = base;
-    this->mmc_cmd.buf_size  = size;
-
-    // call MMC driver
-    error = dev_mmc_access( this );
-
-#if DEBUG_DEV_MMC
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEV_MMC < cycle )
-printk("\n[%s] thread[%x,%x] exit / cluster %x / buffer %x\n", 
-__FUNCTION__, this->process->pid, this->trdid, GET_CXY(buf_xp), GET_PTR(buf_xp) );
-#endif
-
-    return error;
-}
-
-////////////////////////////////////////
-error_t dev_mmc_sync( xptr_t     buf_xp,
-                      uint32_t   buf_size )
-{
-    error_t error;
-
-    thread_t  * this    = CURRENT_THREAD;
-
-#if DEBUG_DEV_MMC
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEV_MMC < cycle )
-printk("\n[%s] thread[%x,%x] enters / cluster %x / buffer %x\n", 
-__FUNCTION__, this->process->pid, this->trdid, GET_CXY(buf_xp), GET_PTR(buf_xp) );
-#endif
-
-    // get buffer cluster and local pointer
-    cxy_t  buf_cxy = GET_CXY( buf_xp );
-    void * buf_ptr = GET_PTR( buf_xp );
-    
-    // force buffer align
-    uint32_t  delta = (uint32_t)buf_ptr & (CONFIG_CACHE_LINE_SIZE - 1); 
-    uint8_t * base  = buf_ptr - delta;
-    uint32_t  size  = buf_size + delta;
-
-    // store command arguments in thread descriptor
-    this->mmc_cmd.dev_xp    = chdev_dir.mmc[buf_cxy];
-    this->mmc_cmd.type      = MMC_CC_SYNC;
-    this->mmc_cmd.buf_ptr   = base;
-    this->mmc_cmd.buf_size  = size;
-
-    // call MMC driver
-    error = dev_mmc_access( this );
-
-#if DEBUG_DEV_MMC
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEV_MMC < cycle )
-printk("\n[%s] thread[%x,%x] exit / cluster %x / buffer %x\n", 
-__FUNCTION__, this->process->pid, this->trdid, GET_CXY(buf_xp), GET_PTR(buf_xp) );
-#endif
-
-    return error;
-}
-
-/////////////////////////////////////////
-error_t dev_mmc_error_set( cxy_t     cxy,
+error_t dev_mmc_set_error( cxy_t     cxy,
                            uint32_t  index,
                            uint32_t  wdata )
@@ -184,15 +180,18 @@
 
     // store command arguments in thread descriptor
-    this->mmc_cmd.dev_xp    = chdev_dir.mmc[cxy];
-    this->mmc_cmd.type      = MMC_ERROR_SET;
-    this->mmc_cmd.reg_index = index;
-    this->mmc_cmd.reg_ptr   = &wdata;
-
-    // execute operation
-    return dev_mmc_access( this ); 
+    this->dev.mmc.dev_xp    = devices_dir.mmc[cxy];
+    this->dev.mmc.type      = MMC_SET_ERROR;
+    this->dev.mmc.reg_index = index;
+    this->dev.mmc.reg_ptr   = &wdata;
+
+    // execute operation
+    dev_mmc_access( this ); 
+
+    // return operation status
+    return this->dev.mmc.error;  
 }
                         
 //////////////////////////////////////////
-error_t dev_mmc_error_get( cxy_t      cxy,
+error_t dev_mmc_get_error( cxy_t      cxy,
                            uint32_t   index,
                            uint32_t * rdata )
@@ -202,28 +201,35 @@
 
     // store command arguments in thread descriptor
-    this->mmc_cmd.dev_xp    = chdev_dir.mmc[cxy];
-    this->mmc_cmd.type      = MMC_ERROR_GET;
-    this->mmc_cmd.reg_index = index;
-    this->mmc_cmd.reg_ptr   = rdata;
-
-    // execute operation
-    return dev_mmc_access( this ); 
+    this->dev.mmc.dev_xp    = devices_dir.mmc[cxy];
+    this->dev.mmc.type      = MMC_GET_ERROR;
+    this->dev.mmc.reg_index = index;
+    this->dev.mmc.reg_ptr   = rdata;
+
+    // execute operation
+    dev_mmc_access( this ); 
+
+    // return operation status
+    return this->dev.mmc.error;  
 }
-
-//////////////////////////////////////////
-error_t dev_mmc_instr_get( cxy_t      cxy,
-                           uint32_t   index,
-                           uint32_t * rdata )
-{
-    // get calling thread local pointer
-    thread_t * this = CURRENT_THREAD;
-
-    // store command arguments in thread descriptor
-    this->mmc_cmd.dev_xp    = chdev_dir.mmc[cxy];
-    this->mmc_cmd.type      = MMC_INSTR_GET;
-    this->mmc_cmd.reg_index = index;
-    this->mmc_cmd.reg_ptr   = rdata;
-
-    // execute operation
-    return dev_mmc_access( this ); 
+                        
+////////////////////////////////////////////////////
+error_t dev_mmc_get_instrumentation( cxy_t      cxy,
+                                     uint32_t   index,
+                                     uint32_t * rdata )
+{
+    // get calling thread local pointer
+    thread_t * this = CURRENT_THREAD;
+
+    // store command arguments in thread descriptor
+    this->dev.mmc.dev_xp    = devices_dir.mmc[cxy];
+    this->dev.mmc.type      = MMC_GET_INSTRU;
+    this->dev.mmc.reg_index = index;
+    this->dev.mmc.reg_ptr   = rdata;
+
+    // execute operation
+    dev_mmc_access( this ); 
+
+    // return operation status
+    return this->dev.mmc.error;  
 }
+
Index: trunk/kernel/devices/dev_mmc.h
===================================================================
--- trunk/kernel/devices/dev_mmc.h	(revision 690)
+++ trunk/kernel/devices/dev_mmc.h	(revision 1)
@@ -2,5 +2,5 @@
  * dev_mmc.h - MMC (Generic L2 cache controller) device API definition.
  *
- * Authors   Alain Greiner  (2016,2017,2018,2019,2020)
+ * Authors   Alain Greiner  (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -25,6 +25,7 @@
 #define _DEV_MMC_H_
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
+#include <almos_config.h>
+#include <hal_types.h>
+#include <spinlock.h>
 
 /*****************************************************************************************
@@ -34,15 +35,10 @@
  * acting in all clusters containing a level 2 cache controller.
  *
- * It supports three different services:
- * 1) L2/L3 software cache-coherence operations.
- * 2) error reporting for architecture specific addressing error.
- * 3) architecture specific intrumentation registers access. 
- *
- * It supports therefore five command types: 
+ * It supports  five command types: 
  * - MMC_CC_INVAL   : invalidate all cache lines covering a given buffer in L2 cache.
  * - MMC_CC_SYNC    : synchronize all cache lines covering a given buffer to L3 cache.
- * - MMC_ERROR_GET  : return content of a given error signaling register.
- * - MMC_ERROR_SET  : set a given error signaling register.
- * - MMC_INSTR_GET  : return content of a given instrumentation register.
+ * - MMC_GET_ERROR  : return content of a given error signaling register.
+ * - MMC_SET_ERROR  : set a given error signaling register.
+ * - MMC_GET_INSTRU : return content of a given instrumentation register.
  *
  * As all L2 caches can be accessed by any thread running in any cluster, a calling
@@ -50,12 +46,8 @@
  * As these operations consume few cycles, and access conflicts are expected to be 
  * rare events, the calling threads use a busy waiting strategy to get the device
- * busylock, but do not register in the device waiting queue, and no server thread
+ * spinlock, do not register in the device waiting queue, and no server thread
  * is used for this device.
  ****************************************************************************************/
  
-/****  Forward declarations  ****/
-
-struct chdev_s;
-
 /******************************************************************************************
  * This enum defines the various implementations of the generic MMC peripheral.
@@ -78,17 +70,17 @@
     MMC_CC_INVAL   = 0,
     MMC_CC_SYNC    = 1,
-    MMC_ERROR_GET  = 2,
-    MMC_ERROR_SET  = 3,
-    MMC_INSTR_GET  = 4,
+    MMC_GET_ERROR  = 2,
+    MMC_SET_ERROR  = 3,
+    MMC_GET_INSTRU = 4,
 };
 
 typedef struct mmc_command_s
 {
-    xptr_t      dev_xp;     /*! extended pointer on target MMC device descriptor        */
+    xptr_t      dev_xp;     /*! extended pointer on the relevant MMC device descriptor  */
     uint32_t    type;       /*! CC_INVAL / CC_SYNC / GET_ERROR / SET_ERROR / GET_INSTRU */
-    void      * buf_ptr;    /*! local pointer on memory buffer    (used by INVAL/SYNC)  */
-    uint32_t    buf_size;   /*! memory buffer size (bytes)        (used by INVAL/SYNC)  */
-    uint32_t    reg_index;  /*! register index in MMC peripheral  (used by SET/GET)     */
-    uint32_t  * reg_ptr;    /*! local pointer on src/dst buffer   (used by SET/GET)     */
+    paddr_t     buf_paddr;  /*! buffer physical address          (used by INVAL/SYNC)   */
+    uint32_t    buf_size;   /*! buffer size in bytes             (used by INVAL/SYNC)   */
+    uint32_t    reg_index;  /*! register index in MMC peripheral (used by SET/GET)      */
+    uint32_t  * reg_ptr;    /*! local pointer on src/dst buffer  (used by SET/GET)      */
     error_t     error;      /*! operation status (0 if success)                         */
 }
@@ -96,40 +88,40 @@
 
 /*****************************************************************************************
- * This function initializes the driver specific fields in the local MMC chdev,  
- * and initializes the implementation specific MMC  driver.
+ * This function initializes the driver specific fields in the generic MMC device 
+ * descriptor, and the implementation specific driver.
  * It must be executed once in any cluster containing an L2 cache.
  *****************************************************************************************
- * @ chdev      : pointer on MMC device descriptor.
+ * @ mmc_xp     : extended pointer on MMC device descriptor.
  ****************************************************************************************/
-void dev_mmc_init( struct chdev_s * chdev );
+void dev_mmc_init( xptr_t  mmc_xp );
 
 /*****************************************************************************************
- * This function invalidates all cache lines covering a memory buffer  defined by 
- * the <buf_xp> and <buf_size> arguments.
+ * This function invalidates all cache lines covering a memory buffer 
+ * in the physical address space. 
  * It can be executed by any thread in any cluster, because it uses remote accesses
  * to access both the MMC device descriptor, and the L2 cache configuration interface.
  *****************************************************************************************
- * @ buf_xp     : extended pointer on memory buffer.
+ * @ buf_paddr  : buffer local physical addresse.
  * @ buf_size   : buffer size (bytes).
  * @ return 0 if success / return EINVAL if failure
  ****************************************************************************************/
-error_t dev_mmc_inval( xptr_t     buf_xp,
-                       uint32_t   buf_size );
+error_t dev_mmc_inval( paddr_t   buf_paddr,
+                       uint32_t  buf_size );
 
 /*****************************************************************************************
  * This function forces the L2 cache to synchronize the L3 cache for all cache lines
- * covering a memory buffer defined by the <buf_xp> and <buf_size> arguments.
+ * covering a memory buffer in the physical address space. 
  * It can be executed by any thread in any cluster, because it uses remote accesses
  * to access both the MMC device descriptor, and the L2 cache configuration interface.
  *****************************************************************************************
- * @ buf_xp     : extended pointer on memory buffer.
+ * @ buf_paddr  : buffer local physical addresse.
  * @ buf_size   : buffer size (bytes).
  * @ return 0 if success / return EINVAL if failure
  ****************************************************************************************/
-error_t dev_mmc_sync( xptr_t     buf_xp,
+error_t dev_mmc_sync( paddr_t    buf_paddr,
                       uint32_t   buf_size );
                         
 /*****************************************************************************************
- * This function set a value in one (architecture specific) MMC_ERROR register.
+ * This function set a value in one error signaling MMC register.
  * It can be executed by any thread in any cluster, because it uses remote accesses
  * to access the L2 cache instrumentation interface in any cluster.
@@ -140,12 +132,12 @@
  * @ return 0 if success / return EINVAL if failure
  ****************************************************************************************/
-error_t dev_mmc_error_set( cxy_t    cxy,
+error_t dev_mmc_set_error( cxy_t    cxy,
                            uint32_t index,
                            uint32_t wdata );
               
 /*****************************************************************************************
- * This function returns the value contained in one (architecture specific) MMC_ERROR
- * register. It can be executed by any thread in any cluster, because it uses remote
- * accesses to access the L2 cache instrumentation interface in any cluster.
+ * This function returns the value contained in one error signaling MMC register.
+ * It can be executed by any thread in any cluster, because it uses remote accesses
+ * to access the L2 cache instrumentation interface in any cluster.
  *****************************************************************************************
  * @ cxy     : MMC cluster identifier.
@@ -154,21 +146,22 @@
  * @ return 0 if success / return EINVAL if failure
  ****************************************************************************************/
-error_t dev_mmc_error_get( cxy_t      cxy,
+error_t dev_mmc_get_error( cxy_t      cxy,
                            uint32_t   index, 
                            uint32_t * rdata );
               
+
 /*****************************************************************************************
- * This function returns the value contained in one (architecture specific) MMC_INSTR
- * register. It can be executed by any thread in any cluster, because it uses remote
- * accesses to access the L2 cache instrumentation interface in any cluster.
+ * This function returns the value contained in one instrumentation MMC register.
+ * It can be executed by any thread in any cluster, because it uses remote accesses
+ * to access the L2 cache configuration interface in any cluster.
  *****************************************************************************************
  * @ cxy     : MMC cluster identifier.
- * @ index   : error register index in MMC peripheral.
+ * @ index   : instrumentation register index in MMC peripheral.
  * @ rdata   : local pointer on buffer for returned value.
  * @ return 0 if success / return EINVAL if failure
  ****************************************************************************************/
-error_t dev_mmc_instr_get( cxy_t      cxy,
-                           uint32_t   index, 
-                           uint32_t * rdata );
-              
+error_t dev_mmc_get_instrumentation( cxy_t      cxy,
+                                     uint32_t   index,
+                                     uint32_t * rdata );
+
 #endif  /* _DEV_MMC_H_ */
Index: trunk/kernel/devices/dev_mwr.h
===================================================================
--- trunk/kernel/devices/dev_mwr.h	(revision 1)
+++ trunk/kernel/devices/dev_mwr.h	(revision 1)
@@ -0,0 +1,120 @@
+/*
+ * dev_mwr.h - MWR (Multi Fifos DMA Controller) generic device API.
+ *
+ * Authors   Alain Greiner  (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTMWRLAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _DEV_MWR_H_
+#define _DEV_MWR_H_
+
+#include <almos_config.h>
+#include <hal_types.h>
+#include <spinlock.h>
+
+/*****************************************************************************************
+ *     Generic multi-fifos DMA controller for harware coprocessors.
+ *
+ ****************************************************************************************/
+ 
+struct device_s;
+
+/*****************************************************************************************
+ * This defines the (implementation independant) extension for the generic MWR device.
+ ****************************************************************************************/
+
+typedef struct mwr_extend_s
+{
+    uint32_t    to_coproc_nr;    /*! actual number of to_coproc FIFOs                   */
+    uint32_t    from_coproc_nr;  /*! actual number of from coproc FIFOs                 */
+    uint32_t    config_nr;       /*! actual number of configuration registers           */
+    uint32_t    status_nr;       /*! actual number of status registers                  */
+}
+mwr_extend_t;
+
+
+/*****************************************************************************************
+ * This function initializes the MWR specific fields of the device descriptor.
+ * It must be executed once in the cluster containing a MWR device descriptor.
+ *****************************************************************************************
+ * @ mwr_xp         : extended pointer on MWR device descriptor.
+ * @ to_coproc_nr   : number of to_coproc fifos.
+ * @ from_coproc_nr : number of from_coproc fifos.
+ * @ config_nr      : number of coprocessor configuration registers.
+ * # status_nr      : number of coprocessor status registers.
+ ****************************************************************************************/
+void dev_mwr_init( xptr_t    mwr_xp,
+                   uint32_t  to_coproc_nr,
+                   uint32_t  from_coproc_nr,
+                   uint32_t  config_nr,
+                   uint32_t  status_nr );
+
+/*****************************************************************************************
+ * This function set a value in one coprocessor register.
+ * It can only be executed by a local thread.
+ *****************************************************************************************
+ * @ cxy     : MMC cluster identifier.
+ * @ index   : register index in MMC peripheral.
+ * @ wdata   : value to be written.
+ ****************************************************************************************/
+void dev_mwr_set_coproc_register( cxy_t    cxy,
+                                  uint32_t index,
+                                  uint32_t wdata );
+
+/*****************************************************************************************
+ * This function returns the value contained in one coprocessor register.
+ * It can only be executed by a local thread.
+ *****************************************************************************************
+ * @ cxy     : MMC cluster identifier.
+ * @ index   : error register index in MMC peripheral.
+ * @ rdata   : local pointer on buffer for returned value.
+ ****************************************************************************************/
+void dev_mmc_get_coproc_register( cxy_t      cxy,
+                                  uint32_t   index, 
+                                  uint32_t * rdata );
+
+/*****************************************************************************************
+ * This function set a value in one channel register.
+ * It can only be executed by a local thread.
+ *****************************************************************************************
+ * @ cxy     : MMC cluster identifier.
+ * @ index   : register index in MMC peripheral.
+ * @ wdata   : value to be written.
+ ****************************************************************************************/
+void dev_mwr_set_channel_register( cxy_t    cxy,
+                                   uint32_t channel,
+                                   uint32_t index,
+                                   uint32_t wdata );
+
+/*****************************************************************************************
+ * This function returns the value contained in one channel register.
+ * It can only be executed by a local thread.
+ *****************************************************************************************
+ * @ cxy     : MMC cluster identifier.
+ * @ index   : error register index in MMC peripheral.
+ * @ rdata   : local pointer on buffer for returned value.
+ ****************************************************************************************/
+void dev_mmc_get_channel_register( cxy_t      cxy,
+                                   uint32_t channel,
+                                   uint32_t   index, 
+                                   uint32_t * rdata );
+
+
+
+#endif  /* _DEV_MWR_H_ */
Index: trunk/kernel/devices/dev_nic.c
===================================================================
--- trunk/kernel/devices/dev_nic.c	(revision 690)
+++ trunk/kernel/devices/dev_nic.c	(revision 1)
@@ -2,5 +2,5 @@
  * dev_nic.c - NIC (Network Controler) generic device API implementation.
  * 
- * Author  Alain Greiner    (2016,2017,2018,2019,2020)
+ * Author  Alain Greiner    (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
